/*
    artifact generator: C:\My\wizzi\stfnbssl\wizzi\packages\wizzi-js\lib\artifacts\js\module\gen\main.js
    package: wizzi-js@0.7.11
    primary source IttfDocument: C:\My\wizzi\stfnbssl\wizzi\packages\wizzi-core\.wizzi\tests\mocks\basicloader\nodifier.js.ittf
*/
'use strict';
var util = require('util');
//
module.exports = function(lines, mTree) {
    var nodes = [],
        root = null,
        current = null,
        nameFirstChar = null,
        nameLength = 0,
        line,
        i,
        l = lines.length;
    for (var i = 0; i < l; i++) {
        line = lines[i];
        nameFirstChar = line.name[0];
        nameLength = line.name.length;
        line.id = mTree.getNewNodeId();
        line.model = mTree;
        if (line.indent == 0 && current == null) {
            line.parent = null;
            nodes.push(line);
        }
        else if (current == null) {
            return error('Malformed tree, root node cannot have an indent.', line, mTree);
        }
        else if (line.indent == current.indent) {
            if (typeof(current.parent) === 'undefined' || current.parent === null) {
                return error('Malformed tree, only one root note allowed.', line, mTree);
            }
            line.parent = current.parent;
            current.parent.children.push(line);
        }
        else if (line.indent > current.indent) {
            if (nameFirstChar == '$' && line.name === '$params') {
                if (current.indent > 0) {
                    return error('The $params node must be a child of the root node.', line, mTree);
                }
                current.model.$params = line.value;
                continue;
            }
            
            // value continuation on new line
            else if (nameFirstChar == '\\' && nameLength == 1) {
                current.value += line.value;
                continue;
            }
            
            // value continuation on new line with space
            else if (nameFirstChar == '\\' && line.name === '\\b') {
                current.value += (' ' + line.value);
                continue;
            }
            
            // value continuation on new line with line break
            else if (nameFirstChar == '\\' && line.name === '\\n') {
                current.value += ('\n' + line.value);
                continue;
            }
            else {
                line.parent = current;
                current.children.push(line);
            }
        }
        else if (line.indent < current.indent) {
            var parent = current.parent;
            while (parent != null && line.indent < parent.indent) {
                parent = parent.parent;
            }
            line.parent = parent.parent;
            if (parent.parent) {
                parent.parent.children.push(line);
            }
            else {
                return error('Malformed tree, only one root note allowed.', line, mTree);
            }
        }
        current = line;
        current.children = [];
    }
    return nodes;
}
;
function error(message, line, mTree) {
    message = message + '\nNode ' + line.name + ' ' + (line.value || '') + ' row: ' + line.row + ' col: ' + line.col + '.\n Filepath: ' + mTree.uri;
    return {
            __is_error: true, 
            message: message, 
            source: 'wizzi-mtree/lib/loader/nodifier'
         };
}
